package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class EmployeeService {

  @Autowired EmployeeRepository employeeRepository;


  public List<Employee> findAllEmployees() {
    /*some business*/
    return employeeRepository.findAll();
  }


  public Employee addEmployee(Employee employee) {
    return employeeRepository.save(employee);
  }

  public Optional<Employee> getEmployeeById(Long employeeId) {
    return employeeRepository.findById(employeeId);
  }

  public void editEmployee(Employee employee, Employee employeeEdit) {
    employee.set(employeeEdit);
    employeeRepository.saveAndFlush(employee);
  }

  public void deleteEmployee(Employee employee) {
    employeeRepository.delete(employee);
  }

  private Map<String, String> queryToMap(String searchQuery){
    String[] queries = searchQuery.split("&");
    Map<String, String> fieldMap = new HashMap<>();
    for (String query:queries){
      String[] fieldVal = query.split("=");
      String field = fieldVal[0];
      String val = fieldVal[1];
      fieldMap.put(field,val);
    }

    return fieldMap;
  }

}
